Hi everyone!

The last elimination round of VK Cup 2017, Round 3, will take place on May 7 at 18:35 MSK (check your timezone here), along with separate Codeforces Round #412 for both divisions. All three rounds will be three hours long, and all three rounds will be rated.

The contest "VK Cup 2017 — Round 3" is for teams qualified from Round 2 or Wildcard Round 2. The top 20 teams will advance to the final which will be held in July 2017 in Saint Petersburg!

Huge thanks to KAN, qwerty787788, PavelKunyavskiy, AlexFetisov, MikeMirzayanov, and VK company for making this round possible.

Codeforces will be the main character of most problems. Don't forget that it's useful to read the statements of all the problems.

Good luck!

As we're in year 2017, the scoring will obviously be static. The exact scoring distribution will be announced before the round.

**UPD 1.** The scoring distribution is:

Div. 1 and VK Cup Round 3: 500 — 1000 — 1750 — 2500 — 2750 — 3500

Div. 2: 500 — 1000 — 1500 — 2000 — 2750 — 3500

**UPD 2.** Due to yesterday's registration troubles the start of the contest is delayed by 10 minutes.

**UPD 3.** Congratulations to the winners!

VK Cup Round 3:

Div. 1:

Div. 2:

**UPD 4.** Tutorial is now available.

My first reaction to round author:

My first reaction to number of upvotes!

Yes. Now tourist is in the Top 10 Contributor!

EDIT: Now he's 7th contributor. Actually this is the first time to see blog with 2000+ upvotes... Wow!

These upvotes prove how much people love tourist

That's my first reaction when I saw that tourist can't take first place in a contest for once.

What does this mean "maybe someone else"?

maybe to himself but he did not like to thank himself

How many problems there will be ?

Yes, how many?

I think, 7 like in the past years.

Boss(tourist) is back in business after a long time .

Why can I register for both contests at the same time?

poor english :/

"Y U NO" is customary for that meme...

I'll go to a trip the day after tomorrow (i.e., get up early) and I was planning to skip this round (it's late night), but the writer is tourist. I must change the sleeping schedule.

that's beauty :D Good luck to You :D

Go to a trip and become a tourist :)

I have an exam tomorrow and I was planning to skip this round too but now I am planning to study hard now to attend the contest.

i'm am participating after 2 months and the writer is tourist :(

What does this means ?!

UPD: Fixed :)

Poor connection :( I'm so sorry for repeating the comment. (edited)

is there a qualification required to participate in the div2 and div1 rounds? , because it says "Registration is private" ... thank you

No, there was a bug in registration settings, we are fixing it, the registration will soon be open again.

thanks , we are expecting a very nice round

Why it shows "Registration is private"?

DIV 2 people right now

I hope Statement.CLEAR && Statement.SHORT() always return true! :)

Good luck everyone!

Register again, to take part in contest.

The round writer is tourist . Do not miss the round!

I guess people took it seriously! this round is gonna be grand tour!

I can break negative contribution record with this comment down votes coming

Nice way of increasing the contribution points...

Nice picture xP

Mine is probably even better

And I thought I was evil!

Boss(tourist) is back in business after a long time .Yeah.

what does it mean that the score will be static?

A-500 B-1000 c-1500 D-2000 E-2500 F-3000

Points don't depend on number of people who solve task.

thank you.

If you want to be "Tourist" , Please visit my country

Nepal. Very Beautiful and We welcome Tourists :Pahahah lol.

)))

Carry out an open programming competition with the onsite final there

Into my mind the problems will be very interesting(and soulves too).

Amazing

Why everyone so excited that the round is by tourist?! it doesn't mean that you participate a round by tourist and you become tourist also :P Go to visit somewhere and do the contest, you'll become a tourist participant of a contest by tourist!

I really hope that tourist could say hello to me.I would be happy all the night,maybe all the year.

work hard all that year and you will become ( or close to ) a tourist :)

Thank you for you encouragement,I try my best to develop myself

I am Arab :| downvotes please

something else, do you have problems with Arabs, because of you people hate Arabs and Afghans, please don't do this "Stupid acts".

everything I want is downvote And I'm also arab :/ They are great people but maybe it is a way for increasing downvotes

He can do anything to get upvotes :| !

You've got it wrong. People usually hate jews, but not arabs =)

In fact people here hate ethnicity-related comments most of all, I think.

so why no downvotes¿

SpoilerA sadist and a masochist were put into the same jail cell and soon found out about each other.

The masochist cried, "Oh, hurt me, pinch me, humiliate me. Please cause me pain!"

The sadist looked at him and said, "No".

Ow I think I can do it this time with this comment: is it rated? GL & HF How many problems there are? Hope for short statements anything missing? please write phrases I should write in this comment

I'm sure that you want to get upvotes.

If you really want to get down votes remove: "Ow I think I can do it this time with this comment"

You can learn from this guy: Comment

I think I can learn also from this person below :| NotMoreThanANoob

try using "Up votes please :) "

P.S. i'm perfectly satisfied with my contribution status, so if you wanna give me down vote, give it to this

-TOPCODER- guy instead and help him reach his dream.

yup, like this guy: Comment

Story of tourist and problems :

tkhkhkhkhkhkhkh soooo interesting :\

Finally a round that tourist cannot take the first place :)

respect for everybody. Did tourist stood first in every contest?

You can check.

so basically whenever he doesn't come first he loses rating? tough job

I have End-Semester exam tommorow. Well fuck it.

More delays?

Rating? Or spend the semester? :'v

Delayed by 10 min

Delay, delay everywhere

Guys instead of fun I want you talk with you. Today I did this with an account to show you in life they are some people like this -topcoder- this people can be so bad for our duty. look, one of the codeforces best blogs ever can be hardly damned with people like this please, please I'm not joking please read this comment and try to remember it, there are many people like this in the real world don't make sense about them and let them for their own! at last be happy and I wish you all a good contest :) Sorry for my poor english :(

bruh.. do u even english?

Ironically enough , it says that he is from MIT :P

I hate delayed contest :(

At least delays are useful for some persons :)

delay, hope it won't be delay as much as 411

Delay again!!

Now 10 minutes late is a common factor of codeforces contest.

There is nothing I hate in codeforces more than the delays xD

Delays for situations like this (yesterday's registration) should be announced a day earlier when the registration failure happens, not 5 minutes before contest start.

I'm the only one that use delays to give contribution points??? I'm nervous, I hope to solve at least three problems...

after hearing the contest is on Sunday:

After hearing it is from tourist:

That's why I love problems of tourist:

NO! Your rate increasement is the reason :/

What if I hate Math! xD xD

Rating drops deeper than Mariana Trench. :)

Fairly difficult contest but great problems by a great problemsetter!

What is test 10 for problem Div2 E? It's driving me insane.

There's definitely something wrong with problem B, I'm sure that my solution is correct but I kept getting wrong answer. Here's my idea, please correct me if I'm wrong: Only tourist can beat Petya, so I printed -1 for all test cases.

In DIV2D/DIV1B, does anybody have an idea, what test case 11 could've been like? Kept failing it.

I got WA once on test 11 with binary search.

A linear scan got pretest passed.

binary search doesnt work always. Take case something like vasya cannot solve some problem and petya can solve it.then u are increasing its points

Yes. I forgot the fact that if i can't have a correct solution for a particular problem, adding new accounts would increase the difference between two's score.

I literally just bruteforced my way until some large enough threshold, say 1e6. Since the original number of participants is quite small (<= 120)

Could you give me an example case that make binary search goes wrong? My idea is binary searching the answer and then using current "fake accounts" i use bitmask for every problem. 0 in the mask represents that all fake accounts must produce "failed submission", 1 in the mask that all fake accounts must produce "accepted". Firstly i check if there is any problem that Vasya hasn't solved yet, the fake account cannot produce the correct answer and move to the next mask. In any mask configuration that makes Vasya score gets higher than Petya, then current answer is able to make the score higher. Mine got WA on pretest 11

What do you mean by linear scan?

for i:=0 to a specific value check adding i accounts submitting solutions in an optimal way satisfies the requirement or not

Greedy?

make all new accounts submit a correct solution to a problem if time[Vasya] > time[Petya] and Vasya has a correct solution to the problem.

Damn. I did it with binary search, because I though a linear function would be too slow.

I'm too... It's so sad(

Got WA on pretest 12 (not 11) with a greedy solution

Why points in scoreboard changed?

Yes, I thought i was going crazy :/

Hack case for Div2.C?

maybe: 1 1 2 0 1

My program prints -1 and answer is -1! passed from this :D

how to solve div2 problem D? Can anyone please help

How to solve Div2C?

About binary search or math to solve it.

binary search

Search what?

Assume p*t/q*t =(x+c1)/(y+c1+c2).

Now binary search for t

But we don't know

c_{1}andc_{2}right?the condition for valid t is c1>=0 and c2>=0

(x+a)/ (y+b) = p/q this implies x+a = pn and y+b = qn for some n. Now apply binary search for n with high as 10^9 , i got the idea late :-/ Hope this helps. Check for conditions in binary search .

Simple math, no need binary search (maybe will fail from systest):

CodeGot AC :)

how is k fixed?? i did binary search on k but failled pretest.

In problem we have to find

ksuch thatk*p-x≤k*q-y. From inequality we get . Then check ifkis answer or not.nice catch!! was solution same as this, or simpler

Firstly, divide p and q by gcd(p, q), next step is binary search parameter m, and check that we can make fraction N / m * q from x / y.

"It is guaranteed that p / q is an irreducible fraction."

Hmm okay, I should carefully read statement.

Solved it using math. we must find n and m integers, n, m >= 0 such as: (x + n) / (x + n + m) = p / q; => n = (p * m + p * x + q * x) / (q — p); and m = (n * q — n * p — p * y + q * x) / p; m = (n * q + q * x) / p — n — y; m = q * (n + x) / p — n — y; Because gcd(q, p) = 1 => n + x = cp, c integer, c >= 0, c minimum so n = cp — x; because n >= 0 => q * (n + x) / p >= n + y so: c >= (y — x) / (q — p) => c = ceil( (y — x) / (q — p) ) Notice that n = cp — x, so if cp — x < 0, we have a contradiction. Finally, c = max(c, ceil(x / p)); we calculate n and then m; we print n + m. be careful with border cases

See the comment at the top of my solution: http://codeforces.com/contest/806/submission/26929314

Could you, please, add a bit more detail to the following transition:

I don't understand how do we go from step 1 to step 2.

This reformulation is the crux of the problem, at least for me. I didn't think of it this way while solvingh; I wrote down #1, didn't think it was useful, decided I had to find k, and tried to write down conditions that would make a given k a valid solution.

However, they are equivalent:

kq-y is b, so the condition kq >= y is just saying b is non-negative.

kp-x is a, so kp>=x is saying a is non-negative.

And kp <= x+(kq-y) is saying a <= b.

What is test 7 about DIV.2 problem B?

How to solve div2 C??? :/

Try using binary search

did that..still got error. What is the upper and lower bound of search?

I used 0 to 10^9

binary search multiple of q/p

yes I did that...check my submission. We basically check multiples of p/q such that it m*p-x <= m*q-y and both of the term >0

Is possible p=0? For example 1 0 2 0 3

That shouldn't be valid since p/q must be irreducible.

Is 0/1 irreducible or reducible?

Irreducible, there surely is a test with 0/1. The statement also says that p >= 0.

I think it can be done in O(1). Multiply q/p by a smallest constant such that newq-newp>=y-x

And how do you find this constant in O(1)? (This is incorrect anyway btw)

Just compare the ratio of difference(denominator-numerator) of the two rational numbers. Code

Interesting, I modified my own correct code to find the constant and it failed on test 1. Code

Used Binary Search. Realized that after making more submissions final value of x/y must be a multiple of p/q.

Let number of successful submissions, total number of submissions and such a multiple be k , d, g an, then g*(q-p) + (x-y) >= 0 and k >= 0 and d >= 0.

The goal is to find the first multiple such that g*(q-p) + (x-y) >= 0. It turns out that we can binary search on the g.

k = g*p-x d = g*q-y

Why I can't see others' solutions?

To force us ask questions "How to solve ...?" here instead of looking at solutions by ourselves :)

While system tests won't ended,you can't see solutions

Actually, I can see them now.

You can see now

For Div2 C, got WA on test pretest 4. What's wrong in my code? 26944035

Fastest start of System Testing this year :o

But it is down now.

We all know why :D :P

Hail tourist :D

Understanding question div 2 B is harder than solving it

How to solve Div.1 D? It is correct that we should find

exactly onepath with cost X and length K to the some vertex U, and choose min(X + minEdge[U] * (n — K)) over all pathes K, U? How to manage this?Let's fix the root u. What we want to find is actually a path from u to some vertex with minimal weight edge attached to it.

Consider sorting the edges and add them one by one, let's say we're adding e(u,v), do we know the shortest path from u to some vertex with minimal weight, using this edge?

We do indeed! it's equal to the weight of the edge, added by the result of vertex v. Notice that if we don't have result of vertex v, we notice that all the "empty" edges have same weight as the edge we just added, so it's weight * 2. Doing it for all edges and you get the answer.

Got it, Thanks!

Problem C [Success Rate]: Case 3 3 5 5 is the answer 0 or 2 ?

p/q is guaranteed to be irreducible.

p/q is guaranteed to be irreducible, the answer is 0 though.

the answer should be 0 since the ratio is the same. btw p/q is irreducible fraction, so your input case is invalid

it is assumed that p/q is irreducible, so this case doesn't exist.

What an end for a contest by tourist. petr wins it with a submission in last minute.!!!

WoW! ... ;)

And also I felt tourist thought to bluff Div1 B as binary search (only my personal opinion)

what should the answer to problem div 2C be for the following output x=0 y=2 p=0 q=3 ?

0, since the ratios are already the same.

Nice Contest and questions were also interesting. Thanks tourist!!

one of the team was "-xray- is gay". And the members are -xray-'s teammates. lol .

Is O(n^3) supposed to get TLE for problem Div2F?

My submission in O(n^3) gets TLE...

http://codeforces.com/contest/807/submission/26945597

I haven't read the problem myself, but given that n is 2000 it should TLE.

Boss(tourist) is back, that's why we have a nice round. :)

Can someone explain mathematical solution of Div1 A / Div2 C ?

Petr's one http://codeforces.com/contest/806/submission/26927108

Find smallest integer t such that 0 <= p*t-x <= q*t-y. Submit q*t-y times and get AC p*t-x times then AC rate wil be p*t/q*t = p/q.

but how to implement it?

i can't understand your formulas for t

(A+B-1)/B means ceil(A÷B).

ok, now its clear. thank you

Petr has started doing screencasts with commentary, so probably we will be able to see his thoughts while he was solving this problem.

I think he stopped doing it, as according to him it affects his thinking ability :(

The most upvoted blog ever on CodeForces!

I just want to know, Am I the only one who spent more than 1 hour to understand Div.2 B? :D

Me too bro

Same Here .... More than 1 Hour .

Very nice round and well-written problems..... on a completely different topic : is there any problem with sharing the rating changes ? i can't see the usual buttons i.e: facebook , twitter ... and thanks again.

in Div2 C this test case" 2 8 8 32 " output 24 and it should be 0 and the code still AC why ???

p and q must be relatively prime

why all my sloved skipped...

It means your solution resembles another's too closely, so either you cheated or you're pretty unlucky.

MikeMirzayanov and the entire codeforces community hates cheaters.

Editorial? Nice set by the way

For 1E, does the following logic work?

If the question just had 1 query for the case of n people, then we simply sort all of them by their estimated rating in ascending order and simulate.

In a different line of thought, consider a fixed arrangement of people visiting the blog. Changing somebody's vote downwards (ie. making him downvote) will never increase the final rating of the blog.

Suppose x people downvote the blog, y people don't vote and z people upvote it in the optimal arrangement. Then, there is an arrangement where we arrange the people in increasing order of estimated rating, enforce that the first x downvote the blog, the next y people don't vote, and the last z upvote the blog. Then this enforcement does not make anybody rate the blog better than usual, implying that the final rating is possible.

Furthermore, if y>=2 people don't vote, this is equivalent to forcing the first of the y people to downvote and letting the last of them upvote, so we may assume y<2.

This means that given a target rating, we can find out x, y and z required. Hence, we may binary search on the score. Queries are equivalent to asking whether the i-th largest element is greater than C-i for i<=k, for some constants C and k. This can be maintained using a modified balanced binary search tree.

Cannot see why it's correct :( Consider this case? 4 1 1 1 1 First one upvote, then the following 3 people does not affect the rating.

uh I meant nondecreasing. Plus I wasn't being very clear I guess.

What I meant is that: if we allow people to change upvotes to no vote/downvotes, and no vote to downvotes, we can achieve the desired format. In this case, we have the first person downvote it (it's not too hard to show that this cannot increase the final rating), then the second person (instead of upvoting) does not vote. Lastly, the last 2 people upvote, for a net +1.

How to solve div 2 C without binary search?

The fraction, that we need to get is fraction of this type: n * p / n * q. Now we need to find n. The only things, that we can do with starting fraction are +1 to denominator and +1 to both denominator and numerator. So, we cannot decrease y — x. That is why let's make an inequation: n * (q — p) >= y — x; n >= (y — x) / (q — p). Also, we cannot decrease numerator, so: n * p >= x; n >= x / p; Now, to find the first n, where the both inequations are correct let's take max of these ceiled values: (y — x) / (q — p) and x / p. The answer is: n * q — y, because the difference between numerators is always <= then difference between denominators due to our first inequation. Also, you shouldn't forget about cornercases, when p = q and when p = 0.

But where is editorial?

here http://codeforces.com/blog/entry/51883

how to solve Div2 D/Div1 B ??

My solution gets like this : iterate all x for 0 to some high value (mine is 10000), this will be our answer. Check whether Vasya's score can be strictly higher than Petya's with current x.

How do we check it? First we do some observations. For every problem, we can either :

a. "maximize its score" (by using all fake account and get unsuccessful submission on this problem). Why is that? Because by using fake account to get unsuccessful submission for this problem, the number of participants increased and the number of solver of this problem remains the same. Therefore, the fraction goes more smaller as x goes higher, so this problem score increase

b. Get all fake account have successful submission for this problem, it will make this problem score decreased. Contrary to the a. Option above, the number of solver and total participants are increased, therefore the fraction goes higher, and the score for this problem decrease.

Since there are only 5 problems in total, bitmasking is not big. we can try all configuration from 0 to 31 for the mask. For each bits of the mask, 0 represents strategy a. While 1 represents strategy b. Then for each configuration, try whether at any point Vasya's score can be greater than Petya's. Please note that to apply strategy b., Vasya must first solve the problem. It's easy to check that if current bit is 1 and Vasya's status is -1, then this bitmask configuration is invalid and try next possible configuration

Why we should try x only to 10000 and not 10^9 + 7? Because at some point the fraction as the number as fake account goes up, the fraction ratio of (solver/total_participant) will be extremely low or high so we can ignore them. Hope my explanation is clear

I didn't check all 32 cases for this problem.

For each problem, Vasya should fake as many successful submissions as possible ONLY IF he solved it and his performance is WORSE THAN Petya's (to decrease this problem's score and minimize the score difference for this problem).

Otherwise, just submit unsuccessful submissions.

thanks, it's very clear. i wasn't able to comeup with bitmasking thing.

nice

Finally 2k17 :D One of the great contest of this year. Learned a lot

What did you learn?

He learned that he should not say "Learned a lot" on Codeforces if he doesn't really mean it. xD

When will the editorial be posted?

It was posted 20 hours ago http://codeforces.com/blog/entry/51883

Sorry I was following this blog. Thanks

I don't think it is posted 20 hours ago. That's the time it is written. It is posted about 3 hours ago. (about when the first comment is posted)

How I check,how many problems I solved in codeforces?

This will work . http://cfviz.netlify.com/